import { Component, OnInit } from '@angular/core';
import { IonHeader, IonToolbar, IonTitle, IonContent } from '@ionic/angular/standalone';
import { IonTextarea, IonButton, IonInput } from "@ionic/angular/standalone";
import { DalleOptions, FmodeChatCompletion, ImagineWork } from 'fmode-ng';

@Component({
  selector: 'app-interest-picture',
  templateUrl: './interest-picture.component.html',
  styleUrls: ['./interest-picture.component.scss'],
  standalone: true,
  imports: [
    IonHeader, IonToolbar, IonTitle, IonContent,
    IonButton,
    IonInput,
    IonTextarea
  ],
})
export class InterestPictureComponent implements OnInit {
  ngOnInit(): void {

  }
  userPrompt: string = "犬吠水声中，桃花带露浓。\n树深时见鹿，溪午不闻钟。"
  promptInput(ev: any) {
    this.userPrompt = ev.detail.value;
  }
  imagineWork: ImagineWork | undefined
  images: Array<string> = []
  constructor(
  ) {
    // 示例任务，自己生成图片后请存储新的ID
    this.imagineWork = new ImagineWork("lpJGiFwWeA");
    this.imagineWork.fetchTask().then(work => {
      this.images = this.imagineWork?.images || [];
    })
  }

  PictureDescResult = ``
  async createImage() {
    this.imagineWork = new ImagineWork();
    let PromptTemplate = `
    您是一名专业的美术画家，请您根据古诗文的内容，将其描述的画面、场景、人物、物品等用最简短的语言表达，直接给出画面，并且以中国古风意境为主，
    诗文如下：
    ${this.userPrompt}
    `
    let completion = new FmodeChatCompletion([
      { role: "system", content: "" },
      { role: "user", content: PromptTemplate }
    ])
    completion.sendCompletion().subscribe((message: any) => {
      // 打印消息体
      console.log(message.content)
      // 赋值消息内容给组件内属性
      this.PictureDescResult = message.content
      if (message?.complete) {
        let PicturePrompt
        let options: DalleOptions = { prompt: this.userPrompt }
        this.imagineWork?.draw(options).subscribe(work => {
          console.log("imagineWork", work?.toJSON())
          console.log("images", work?.get("images"))
          if (work?.get("images")?.length) {
            this.images = work?.get("images");
          }
        })
      }
    })
  }

}